﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using Infragistics.Controls.Grids;
using System.Windows;

namespace WpfApplication288.ViewModel
{
  public  class VM
    {

      DataTemplate dt = Application.Current.Resources["dt"] as DataTemplate;
      
      ObservableCollection<Person> people = new ObservableCollection<Person>();
      public ObservableCollection<Person> People
      {
          get { return people; }
          set { people = value; }
      }
      Dictionary<string, object> rperson = new Dictionary<string, object>();
      ObservableCollection<Dictionary<string,object>> rpeople = new ObservableCollection<Dictionary<string,object>>();
      public ObservableCollection<Dictionary<string, object>> RPeople
      {
          get { return rpeople; }
          set { rpeople = value; }
      }


      public VM()
      {
          for (int i = 0; i < 10; i++)
          {
              Person p = new Person()
              {
                  Name = "name " + i.ToString(),
              };
              people.Add(p);
              for (int j = 0; j < 5 ; j++)
              {
                   Role r = new Role()
                   {
                        Name = "role " + j.ToString(),
                         CreationDate = DateTime.Now.AddYears(-j),
                          Status = ( i % 2 == 1)
                   };
                  p.Roles.Add(r);
              }
          }
          LoadData();
           
      }

      public void LoadData()
      {
          foreach (Person p in people)
          {
              rpeople.Add(CreateDictionary(p));
          }
      }

      public Dictionary<string, object> CreateDictionary(Person a)
      {
          Dictionary<string, object> row = new Dictionary<string, object>();
          row.Add("Name", a.Name);
          for (int i = 0; i < a.Roles.Count; i++)
          {
              string s = a.Roles[i].Name;
              row.Add(s, a.Roles[i]);
              //    row.Add(a.Periods[i].PeriodID.ToString(), a.Periods[i].Val);

          }
         
          return row;

      }

      public void AddGridColumns(ColumnBaseCollection columns, Dictionary<string, object> values)
      {
          foreach (string key in values.Keys)
          {

              if (values[key] is string || values[key] is int)
                  // Use a TextColumn for strings and integers
                  columns.Add(new TextColumn { Key = "[" + key + "]", HeaderText = key.Replace('y', ' ') });
              else if (values[key] is bool)
                  // Use a CheckBoxColumn for booleans
                  columns.Add(new CheckBoxColumn { Key = "[" + key + "]", HeaderText = key, });
              else if (values[key] is Role)
              {
                  columns.Add(new TextColumn { Key = "[" + key + "]", ValueConverter = new TestConverter(),  HeaderText = key.Replace('y', ' ') });
              }
              else if (values[key] is Role)
              {
                  columns.Add(new TemplateColumn { Key = "[" + key + "]", HeaderText = key,   ItemTemplate = dt });
              }
              else if (values[key] is ObservableCollection<Dictionary<string, object>>)
              {
                  // If the data type is a collection then we want a ColumnLayout for showing child bands
                  ObservableCollection<Dictionary<string, object>> childRows = values[key] as ObservableCollection<Dictionary<string, object>>;
                  ColumnLayout colLayout = new ColumnLayout { Key = "[" + key + "]" };

                  // Call this function recursively to add to the columns of the ColumnLayout
                  AddGridColumns(colLayout.Columns, childRows[0]);

                  columns.Add(colLayout);
              }
          }
      }
    }
}
